package testw32apianno;
import utildll.*;
public class TestW32API4 {
	final static int CHARSET = Arg.UNICODE;
	//final static int CHARSET = Arg.ANSI;

	public static void main(String[] args) {
		new TestW32API4();
	}
	
	TestW32API4() {
		
		Arg_EnumSystemLocales aesl = new Arg_EnumSystemLocales(new Func_EnumLocalesProc(), 1);

		boolean blRtnVal = JInvoker.callBooleanProc("EnumSystemLocales", "kernel32", aesl);

		System.out.println("EnumSystemLocales rtn: " + Boolean.toString(blRtnVal)
			+ " LastError: " + Integer.toString(aesl.getLastError()));
	}
}

/*
BOOL EnumSystemLocales(
  LOCALE_ENUMPROC lpLocaleEnumProc, // R[obN֐ւ̃|C^
  DWORD dwFlags   // 񋓂郍P[w肷tO
);
 */
@_CharSet(TestW32API4.CHARSET)
class Arg_EnumSystemLocales {
	private int _LastError;
	
	private @_FuncPtr Func_EnumLocalesProc lpLocaleEnumProc;
	private int dwFlags; //LCID_INSTALLED:1 LCID_SUPPORTED:2 LCID_ALTERNATE_SORTS:4
	
	Arg_EnumSystemLocales(Func_EnumLocalesProc lpLocaleEnumProc, int dwFlags) {
		this.lpLocaleEnumProc = lpLocaleEnumProc;
		this.dwFlags = dwFlags;
	}
	int getLastError() {return _LastError;}
}

class Func_EnumLocalesProc {
	private String _FuncName = "EnumLocalesProc";
	private int _ReturnType = Func.RTNTYPE_BOOLEAN;
	private Arg_EnumLocalesProc _FuncArg = new Arg_EnumLocalesProc();
	private ClsEnumLocalesProc _Instance = new ClsEnumLocalesProc();
	//private String _ClassName = "testw32apianno.ClsStaticEnumLocalesProc";
}

/*
BOOL CALLBACK EnumLocalesProc(
  LPTSTR lpLocaleString   // P[ʎq\ւ̃|C^
);
 */
@_CharSet(TestW32API4.CHARSET)
class Arg_EnumLocalesProc {
	private @_Const String lpCodePageString;

	String getCodePageString() {return lpCodePageString;}
}

class ClsEnumLocalesProc {
	boolean EnumLocalesProc(Arg_EnumLocalesProc aelp) {
		System.out.println("EnumLocalesProc lpCodePageString:" + aelp.getCodePageString());
		return true;
	}
}

class ClsStaticEnumLocalesProc {
	static boolean EnumLocalesProc(Arg_EnumLocalesProc aelp) {
		System.out.println("static EnumLocalesProc lpCodePageString:" + aelp.getCodePageString());
		return true;
	}
}

