package testw32apinew;
import utildll.*;
/*
typedef struct FARSTRUCT tagSAFEARRAY {
   unsigned short cDims;        // Count of dimensions in this array.
   unsigned short fFeatures;    // Flags used by the SafeArray
   unsigned long cbElements;    // Size of an element of the array.
   unsigned long cLocks;        // Number of times the array has been locked without corresponding unlock.
   void HUGEP* pvData;          // Pointer to the data.
   SAFEARRAYBOUND rgsabound[1]; // One bound for each dimension.
} SAFEARRAY;
 */
public class Struct_SAFEARRAY {
	short cDims;
	short fFeatures;
	int cbElements;
	int cLocks;
	Object pvData;
	@_Length_is("cDims") @_Fixed Struct_SAFEARRAYBOUND[] rgsabound;
	
	public Struct_SAFEARRAY(short cDims, short fFeatures, int cbElements, Object pvData,
			Struct_SAFEARRAYBOUND[] rgsabound) {
		this.cDims = cDims;
		this.fFeatures = fFeatures;
		this.cbElements = cbElements;
		this.cLocks = 0;
		this.pvData = pvData;
		this.rgsabound = rgsabound;
	}
	public Struct_SAFEARRAY(){
		this((short)0, (short)0, 0, null, null);
	}
}

/*
typedef struct tagSAFEARRAYBOUND {
   unsigned long cElements;
   long lLbound;
} SAFEARRAYBOUND;
*/

class Struct_SAFEARRAYBOUND {
	int cElements;
	int lLbound;
	
	Struct_SAFEARRAYBOUND(int cElements, int lLbound) {
		this.cElements = cElements;
		this.lLbound = lLbound;
	}
	Struct_SAFEARRAYBOUND(){
		this(0, 0);
	}
}