package testw32apinew;
import utildll.*;

public class TestW32API31 {
	static final int CHARSET = Arg.UNICODE;
	//static final int CHARSET = Arg.ANSI; //s
	
	public static void main(String[] args) {
		new TestW32API31();
	}
	TestW32API31() {
		
		Arg_CoInitializeEx acie = new Arg_CoInitializeEx(ObjBase_h.COINIT_MULTITHREADED);
		
		int intRtnVal = JInvoker.callIntProc("CoInitializeEx", "ole32", acie);

		System.out.println("CoInitializeEx rtn: " + Integer.toHexString(intRtnVal)
				+ " LastError: " + Integer.toString(acie.getLastError()));
		
		if (WinError_h.SUCCEEDED(intRtnVal)){
			Struct_IID pclsid = new Struct_IID();
			Arg_CLSIDFromProgID acfp = new Arg_CLSIDFromProgID("Scripting.FileSystemObject", pclsid);
			
			intRtnVal = JInvoker.callIntProc("CLSIDFromProgID", "ole32", acfp);
			
			System.out.println("CLSIDFromProgID rtn: " + Integer.toHexString(intRtnVal)
					+ " LastError: " + Integer.toString(acfp.getLastError()));
			System.out.println("pclsid: " + pclsid.toString_IID());
			
			if (WinError_h.SUCCEEDED(intRtnVal)){
				int[] pDispatch = new int[1];
				Struct_IID IID_IDispatch = new Struct_IID(
						"00020400-0000-0000-c000-000000000046");
	
				Arg_CoCreateInstance acci = new Arg_CoCreateInstance(pclsid, 
						WTypes_h.CLSCTX_INPROC_SERVER, IID_IDispatch, pDispatch);
				
				intRtnVal = JInvoker.callIntProc("CoCreateInstance", "ole32", acci);
				
				System.out.println("CoCreateInstance rtn: " + Integer.toHexString(intRtnVal)
						+ " LastError: " + Integer.toString(acci.getLastError())
						+ " ppv: " + Integer.toHexString(pDispatch[0]));
				
				if (WinError_h.SUCCEEDED(intRtnVal)){
					Struct_IID IID_NULL = new Struct_IID();
					int[] dispid = new int[1];
					
					Arg_GetIDsOfNames agion = new Arg_GetIDsOfNames(IID_NULL,
							new String[]{"Drives"}, 1,
							WinNT_h.LOCALE_SYSTEM_DEFAULT, dispid);
					
					intRtnVal = JInvoker.callIntMethod(pDispatch[0], OAIdl_h.OFFSET_GetIDsOfNames, agion);
					
					System.out.println("GetIDsOfNames rtn: " + Integer.toHexString(intRtnVal)
							+ " LastError: " + Integer.toString(agion.getLastError())
							+ " dispid: " + Integer.toHexString(dispid[0]));
					
					if (WinError_h.SUCCEEDED(intRtnVal)){
						Struct_DISPPARAMS pDispParams = new Struct_DISPPARAMS(
								null, null, 0, 0);
						Struct_VARIANT pVarResult = new Struct_VARIANT();
						Struct_EXCEPINFO pExcepInfo = new Struct_EXCEPINFO();
						int[] puArgErr = new int[1];
						Arg_Invoke ai = new Arg_Invoke(dispid[0], IID_NULL,
								WinNT_h.LOCALE_SYSTEM_DEFAULT, (short)OleAuto_h.DISPATCH_PROPERTYGET,
								pDispParams, pVarResult, pExcepInfo, puArgErr);
						
						intRtnVal = JInvoker.callIntMethod(pDispatch[0], OAIdl_h.OFFSET_Invoke, ai);
						
						System.out.println("Invoke rtn: " + Integer.toHexString(intRtnVal)
								+ " LastError: " + Integer.toString(ai.getLastError())
								+ " pVarResult vt: " + Integer.toHexString(pVarResult.vt)
								+ " pdispVal: " + Integer.toHexString(pVarResult.uvn3.pdispVal)
								+ " puArgErr: " + Integer.toHexString(puArgErr[0]));
						
						if (WinError_h.SUCCEEDED(intRtnVal)){
							driveCollection(pVarResult.uvn3.pdispVal);
							
							Arg_Release ar = new Arg_Release();
							
							intRtnVal = JInvoker.callIntMethod(pVarResult.uvn3.pdispVal, OAIdl_h.OFFSET_Release, ar);
							
							System.out.println("Release driveCollection rtn: " + Integer.toHexString(intRtnVal)
									+ " LastError: " + Integer.toString(ar.getLastError()));
						}
					}
					Arg_Release ar = new Arg_Release();
					
					intRtnVal = JInvoker.callIntMethod(pDispatch[0], OAIdl_h.OFFSET_Release, ar);
					
					System.out.println("Release rtn: " + Integer.toHexString(intRtnVal)
							+ " LastError: " + Integer.toString(ar.getLastError()));
				}
			}
			JInvoker.callVoidProc("CoUninitialize", "ole32", null);
		}
	}
	
	void driveCollection(int pDispatch){
		Struct_IID IID_NULL = new Struct_IID();
		Struct_DISPPARAMS pDispParams = new Struct_DISPPARAMS(
				null, null, 0, 0);
		Struct_VARIANT pVarResult = new Struct_VARIANT();
		Struct_EXCEPINFO pExcepInfo = new Struct_EXCEPINFO();
		int[] puArgErr = new int[1];
		Arg_Invoke ai = new Arg_Invoke(OAIdl_h.DISPID_NEWENUM, IID_NULL,
				WinNT_h.LOCALE_SYSTEM_DEFAULT, (short)OleAuto_h.DISPATCH_PROPERTYGET,
				pDispParams, pVarResult, pExcepInfo, puArgErr);
		
		int intRtnVal = JInvoker.callIntMethod(pDispatch, OAIdl_h.OFFSET_Invoke, ai);
		
		System.out.println("Invoke rtn: " + Integer.toHexString(intRtnVal)
				+ " LastError: " + Integer.toString(ai.getLastError())
				+ " pVarResult vt: " + Integer.toHexString(pVarResult.vt)
				+ " punkVal: " + Integer.toHexString(pVarResult.uvn3.punkVal)
				+ " puArgErr: " + Integer.toHexString(puArgErr[0]));

		if (WinError_h.SUCCEEDED(intRtnVal)){
			enumDrives(pVarResult.uvn3.punkVal);

			Arg_Release ar = new Arg_Release();
			
			intRtnVal = JInvoker.callIntMethod(pVarResult.uvn3.punkVal, OAIdl_h.OFFSET_Release, ar);
			
			System.out.println("Release DISPID_NEWENUM rtn: " + Integer.toHexString(intRtnVal)
					+ " LastError: " + Integer.toString(ar.getLastError()));
		}
	}
	
	void enumDrives(int pUnknown){
		Struct_IID IID_IEnumVARIANT = new Struct_IID(
				"00020404-0000-0000-c000-000000000046");
		int[] ppvObject = new int[1];
		
		Arg_QueryInterface aqi = new Arg_QueryInterface(IID_IEnumVARIANT, ppvObject);
		
		int intRtnVal = JInvoker.callIntMethod(pUnknown, OAIdl_h.OFFSET_QueryInterface, aqi);
		
		System.out.println("QueryInterface rtn: " + Integer.toHexString(intRtnVal)
				+ " LastError: " + Integer.toString(aqi.getLastError())
				+ " ppvObject: " + Integer.toHexString(ppvObject[0]));
		
		if (WinError_h.SUCCEEDED(intRtnVal)){
			enumVARIANT(ppvObject[0]);

			Arg_Release ar = new Arg_Release();
			
			intRtnVal = JInvoker.callIntMethod(ppvObject[0], OAIdl_h.OFFSET_Release, ar);
			
			System.out.println("Release IEnumVARIANT rtn: " + Integer.toHexString(intRtnVal)
					+ " LastError: " + Integer.toString(ar.getLastError()));
		}
	}
	
	void enumVARIANT(int pDispatch){
		Struct_VARIANT rgVar;
		int[] pCeltFetched;
		Arg_Next an;
		do {
			rgVar = new Struct_VARIANT();
			pCeltFetched = new int[1];
			an = new Arg_Next(1, rgVar, pCeltFetched);
			
			int intRtnVal = JInvoker.callIntMethod(pDispatch, OAIdl_h.OFFSET_Next, an);
			
			System.out.println("Next rtn: " + Integer.toHexString(intRtnVal)
					+ " LastError: " + Integer.toString(an.getLastError())
					+ " rgVar vt: " + Integer.toHexString(rgVar.vt)
					+ " pdispVal: " + Integer.toHexString(rgVar.uvn3.pdispVal)
					+ " pCeltFetched: " + Integer.toHexString(an.pCeltFetched[0]));
			
			if (WinError_h.SUCCEEDED(intRtnVal) && an.pCeltFetched[0] > 0){
				printDriveInfo(rgVar.uvn3.pdispVal);
				
				Arg_Release ar = new Arg_Release();
				
				intRtnVal = JInvoker.callIntMethod(rgVar.uvn3.pdispVal, OAIdl_h.OFFSET_Release, ar);
				
				System.out.println("Release rtn: " + Integer.toHexString(intRtnVal)
						+ " LastError: " + Integer.toString(ar.getLastError()));
			}
		} while (an.pCeltFetched[0] > 0);
	}
	
	void printDriveInfo(int pDispatch){
		Struct_IID IID_NULL = new Struct_IID();
		Struct_DISPPARAMS pDispParams = new Struct_DISPPARAMS(
				null, null, 0, 0);
		Struct_VARIANT pVarResult = new Struct_VARIANT();
		Struct_EXCEPINFO pExcepInfo = new Struct_EXCEPINFO();
		int[] puArgErr = new int[1];
		Arg_Invoke ai = new Arg_Invoke(OAIdl_h.DISPID_VALUE, IID_NULL,
				WinNT_h.LOCALE_SYSTEM_DEFAULT, (short)OleAuto_h.DISPATCH_PROPERTYGET,
				pDispParams, pVarResult, pExcepInfo, puArgErr);
		
		int intRtnVal = JInvoker.callIntMethod(pDispatch, OAIdl_h.OFFSET_Invoke, ai);
		
		System.out.println("Invoke rtn: " + Integer.toHexString(intRtnVal)
				+ " LastError: " + Integer.toString(ai.getLastError())
				+ " pVarResult vt: " + Integer.toHexString(pVarResult.vt)
				+ " bstrVal: " + pVarResult.uvn3.bstrVal
				+ " puArgErr: " + Integer.toHexString(puArgErr[0]));
	}
	
	class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	/*
	HRESULT CoInitializeEx(
	  void * pvReserved,  //Reserved
	  DWORD dwCoInit      //COINIT value
	);
	 */
	class Arg_CoInitializeEx extends Arg_property {
		private @_In Object pvReserved = null;
		private @_In int dwCoInit;
		
		Arg_CoInitializeEx(int dwCoInit){
			this.dwCoInit = dwCoInit;
		}
	}
	
	/*
	void CoUninitialize( );
	 */
	
	/*
	HRESULT CLSIDFromProgID(
	  LPCOLESTR lpszProgID,  //Pointer to the ProgID
	  LPCLSID pclsid         //Pointer to the CLSID
	);
	 */
	@_CharSet(CHARSET)
	class Arg_CLSIDFromProgID extends Arg_property {
		private @_In String lpszProgID;
		private @_Out Struct_IID pclsid;
		
		Arg_CLSIDFromProgID(String lpszProgID, Struct_IID pclsid){
			this.lpszProgID = lpszProgID;
			this.pclsid = pclsid;
		}
	}
	
	/*
	STDAPI CoCreateInstance(
	  REFCLSID rclsid,     //Class identifier (CLSID) of the object
	  LPUNKNOWN pUnkOuter, //Pointer to controlling IUnknown
	  DWORD dwClsContext,  //Context for running executable code
	  REFIID riid,         //Reference to the identifier of the interface
	  LPVOID * ppv         //Address of output variable that receives 
	                       // the interface pointer requested in riid
	);
	 */
	class Arg_CoCreateInstance extends Arg_property {
		private @_In Struct_IID rclsid;
		private @_In int pUnkOuter = 0;
		private @_In int dwClsContext;
		private @_In Struct_IID riid;
		private @_Out int[] ppv;
		
		Arg_CoCreateInstance(Struct_IID rclsid, int dwClsContext, Struct_IID riid, int[] ppv){
			this.rclsid = rclsid;
			this.dwClsContext = dwClsContext;
			this.riid = riid;
			this.ppv = ppv;
		}
	}
	
	/*
	HRESULT QueryInterface( 
		REFIID iid, 
		void **ppvObject
	);
	 */
	class Arg_QueryInterface extends Arg_property {
		private @_In Struct_IID iid;
		private @_Out int[] ppvObject;
		
		Arg_QueryInterface(Struct_IID iid, int[] ppvObject){
			this.iid = iid;
			this.ppvObject = ppvObject;
		}
	}
	
	/*
	ULONG Release(void);
	 */
	class Arg_Release extends Arg_property {
	}
	
	/*
	HRESULT GetIDsOfNames( 
	  REFIID  riid,                  
	  OLECHAR FAR* FAR*  rgszNames,  
	  unsigned int  cNames,          
	  LCID   lcid,                   
	  DISPID FAR*  rgDispId          
	);
	 */
	@_CharSet(CHARSET)
	class Arg_GetIDsOfNames extends Arg_property {
		private @_In Struct_IID riid;
		private @_In String[] rgszNames;
		private @_In int cNames;
		private @_In int lcid;
		private @_Out int[] rgDispId;
		
		Arg_GetIDsOfNames(Struct_IID riid, String[] rgszNames,
				int cNames, int lcid, int[] rgDispId){
			this.riid = riid;
			this.rgszNames = rgszNames;
			this.cNames = cNames;
			this.lcid = lcid;
			this.rgDispId = rgDispId;
		}
	}
	
	/*
	HRESULT Invoke( 
		DISPID dispIdMember, 
		REFIID riid,
		LCID lcid, 
		WORD wFlags, 
		DISPPARAMS FAR *pDispParams, 
		VARIANT FAR *pVarResult, 
		EXCEPINFO FAR *pExcepInfo, 
		unsigned int FAR *puArgErr
	);
	 */
	class Arg_Invoke extends Arg_property {
		private @_In int dispIdMember;
		private @_In Struct_IID riid;
		private @_In int lcid;
		private @_In short wFlags;
		private @_In @_Out Struct_DISPPARAMS pDispParams;
		private @_Out Struct_VARIANT pVarResult;
		private @_Out Struct_EXCEPINFO pExcepInfo;
		private @_Out int[] puArgErr;
		
		Arg_Invoke(int dispIdMember, Struct_IID riid, int lcid, short wFlags,
				Struct_DISPPARAMS pDispParams, Struct_VARIANT pVarResult,
				Struct_EXCEPINFO pExcepInfo, int[] puArgErr){
			this.dispIdMember = dispIdMember;
			this.riid = riid;
			this.lcid = lcid;
			this.wFlags = wFlags;
			this.pDispParams = pDispParams;
			this.pVarResult = pVarResult;
			this.pExcepInfo = pExcepInfo;
			this.puArgErr = puArgErr;
		}
	}
	
	/*
	HRESULT Next( 
		unsigned long celt, 
		VARIANT FAR *rgVar, 
		unsigned long FAR *pCeltFetched
	);
	 */
	class Arg_Next extends Arg_property {
		private @_In int celt;
		private @_Out Struct_VARIANT rgVar;
		private @_Out int[] pCeltFetched;
		
		Arg_Next(int celt, Struct_VARIANT rgVar, int[] pCeltFetched){
			this.celt = celt;
			this.rgVar = rgVar;
			this.pCeltFetched = pCeltFetched;
		}
	}

}
