package testw32apianno;
import utildll.*;
public class TestW32API10 {
	static final int CHARSET = Arg.UNICODE;
	//static final int CHARSET = Arg.ANSI;

	public static void main(String[] args) {
		new TestW32API10();
	}

	TestW32API10() {

		Arg_GetEnvironmentStrings ages = new Arg_GetEnvironmentStrings();
		
		int intEnvStr = JInvoker.callIntProc("GetEnvironmentStrings", "kernel32", ages);

		System.out.println("GetEnvironmentStrings rtn: " + Integer.toString(intEnvStr)
				+ " LastError:" + Integer.toString(ages.getLastError()));
		
		int intStr = intEnvStr;
		
		Arg_lstrlen asl = new Arg_lstrlen(intStr);
		
		int intLen = JInvoker.callIntProc("lstrlen", "kernel32", asl);
		
		//System.out.println("lstrlen rtn: " + Integer.toString(intLen)
		//		+ " LastError:" + Integer.toString(asl.getLastError()));
		
		while(intLen > 0) {
			
			Arg_lstrcpy asc = new Arg_lstrcpy(intLen, intStr);
			
			JInvoker.callVoidProc("lstrcpy", "kernel32", asc);
			
			//System.out.println("lstrcpy rtn: " + asc.lpString1
			//		+ " LastError:" + Integer.toString(asl.getLastError()));
			
			System.out.println(asc.lpString1);
			
			if (CHARSET == Arg.UNICODE) 
				intStr += (intLen + 1) * 2;
			else
				intStr += intLen + 1;
			
			asl = new Arg_lstrlen(intStr);
			
			intLen = JInvoker.callIntProc("lstrlen", "kernel32", asl);
			
			//System.out.println("lstrlen rtn: " + Integer.toString(intLen)
			//		+ " LastError:" + Integer.toString(asl.getLastError()));
			
		}
		
		Arg_FreeEnvironmentStrings afes = new Arg_FreeEnvironmentStrings(intEnvStr);
		
		boolean blRtnVal = JInvoker.callBooleanProc("FreeEnvironmentStrings", "kernel32", afes);

		System.out.println("FreeEnvironmentStrings rtn: " + Boolean.toString(blRtnVal)
				+ " LastError:" + Integer.toString(afes.getLastError()));
	}
	
	/*
	LPVOID GetEnvironmentStrings(VOID);
	 */
	@_CharSet(CHARSET)
	class Arg_GetEnvironmentStrings {
		private int _LastError;
		
		int getLastError() {return _LastError;}
	}
	
	/*
	BOOL FreeEnvironmentStrings(
	  LPTSTR lpszEnvironmentBlock  // ubN
	);
	 */
	@_CharSet(CHARSET)
	class Arg_FreeEnvironmentStrings {
		private int _LastError;
		
		private int lpszEnvironmentBlock;
		
		Arg_FreeEnvironmentStrings(int lpszEnvironmentBlock) {
			this.lpszEnvironmentBlock = lpszEnvironmentBlock;
		}
		int getLastError() {return _LastError;}
	}
	
	/*
	LPTSTR lstrcpy(
	  LPTSTR lpString1,  // Rs[̃obt@
	  LPCTSTR lpString2  // Rs[̕
	);
	 */
	@_CharSet(CHARSET)
	class Arg_lstrcpy {
		private int _LastError;
		
		private String lpString1;
		private int lpString2;
		
		Arg_lstrcpy(int intLen, int lpString2) {
			StringBuffer sb = new StringBuffer(intLen);
			for (int i = 0; i < intLen; i++) {
				sb.append(' ');
			}
			this.lpString1 = sb.toString();
			this.lpString2 = lpString2;
		}
		int getLastError() {return _LastError;}
	}
	
	/*
	int lstrlen(
	  LPCTSTR lpString   // 擾ׂ
	);
	 */
	@_CharSet(CHARSET)
	class Arg_lstrlen {
		private int _LastError;
		
		private int lpString;
		
		Arg_lstrlen(int lpString) {
			this.lpString = lpString;
		}
		int getLastError() {return _LastError;}
	}
	
	
	
	
}